//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%44ECC6CC0237.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%44ECC6CC0237.cm

//## begin module%44ECC6CC0237.cp preserve=no
//## end module%44ECC6CC0237.cp

//## Module: RandomLux%44ECC6CC0237; Package specification
//## Subsystem: XSUtil::Numerics%41E6D0F3003C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Numerics/RandomLux.h

#ifndef RANDOMLUX
#define RANDOMLUX 1

//## begin module%44ECC6CC0237.additionalIncludes preserve=no
//## end module%44ECC6CC0237.additionalIncludes

//## begin module%44ECC6CC0237.includes preserve=yes
//## end module%44ECC6CC0237.includes

//## begin module%44ECC6CC0237.declarations preserve=no
//## end module%44ECC6CC0237.declarations

//## begin module%44ECC6CC0237.additionalDeclarations preserve=yes
//## end module%44ECC6CC0237.additionalDeclarations


//## Modelname: XSUtil::Numerics%3F6F5A7603D4
namespace Numerics {
    //## begin Numerics%3F6F5A7603D4.initialDeclarations preserve=yes
    //## end Numerics%3F6F5A7603D4.initialDeclarations

    //## begin Numerics::RandomLux%44ECC77F015A.preface preserve=yes
/*       Subtract-and-borrow random number generator proposed by
         Marsaglia and Zaman, implemented by F. James with the name
         RCARRY in 1991, and later improved by Martin Luescher
         in 1993 to produce "Luxury Pseudorandom Numbers".
     Fortran 77 coded by F. James, 1993
     Translated to C++ by C. Gordon, 2006

   LUXURY LEVELS.
   ------ ------      The available luxury levels are:

  level 0  (p=24): equivalent to the original RCARRY of Marsaglia
           and Zaman, very long period, but fails many tests.
  level 1  (p=48): considerable improvement in quality over level 0,
           now passes the gap test, but still fails spectral test.
  level 2  (p=97): passes all known tests, but theoretically still
           defective.
  level 3  (p=223): DEFAULT VALUE.  Any theoretically possible
           correlations have very small chance of being observed.
  level 4  (p=389): highest possible luxury, all 24 bits chaotic.

!!! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!!!  Calling sequences for RANLUX:                                  ++
!!!      CALL RANLUX (RVEC, LEN)   returns a vector RVEC of LEN     ++
!!!                   32-bit random floating point numbers between  ++
!!!                   zero (not included) and one (also not incl.). ++
!!!      CALL RLUXGO(LUX,INT,K1,K2) initializes the generator from  ++
!!!               one 32-bit integer INT and sets Luxury Level LUX  ++
!!!               which is integer between zero and MAXLEV, or if   ++
!!!               LUX .GT. 24, it sets p=LUX directly.  K1 and K2   ++
!!!               should be set to zero unless restarting at a break++ 
!!!               point given by output of RLUXAT (see RLUXAT).     ++
!!!      CALL RLUXAT(LUX,INT,K1,K2) gets the values of four integers++
!!!               which can be used to restart the RANLUX generator ++
!!!               at the current point by calling RLUXGO.  K1 and K2++
!!!               specify how many numbers were generated since the ++
!!!               initialization with LUX and INT.  The restarting  ++
!!!               skips over  K1+K2*E9   numbers, so it can be long.++
!!!   A more efficient but less convenient way of restarting is by: ++
!!!      CALL RLUXIN(ISVEC)    restarts the generator from vector   ++
!!!                   ISVEC of 25 32-bit integers (see RLUXUT)      ++
!!!                (Note that unlike RLUXGO this does NOT seed an   ++
!!!                uninitialized generator -C.G.)                   ++                
!!!      CALL RLUXUT(ISVEC)    outputs the current values of the 25 ++
!!!                 32-bit integer seeds, to be used for restarting ++
!!!      ISVEC must be dimensioned 25 in the calling program        ++
!!! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/
    //## end Numerics::RandomLux%44ECC77F015A.preface

    //## Class: RandomLux%44ECC77F015A
    //## Category: XSUtil::Numerics%3F6F5A7603D4
    //## Subsystem: XSUtil::Numerics%41E6D0F3003C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class RandomLux 
    {
      //## begin Numerics::RandomLux%44ECC77F015A.initialDeclarations preserve=yes
      //## end Numerics::RandomLux%44ECC77F015A.initialDeclarations

      public:
        //## Constructors (generated)
          RandomLux();

        //## Destructor (generated)
          ~RandomLux();


        //## Other Operations (specified)
          //## Operation: rluxgo%44ECCACD0363
          void rluxgo (int lux, int ins, int k1, int k2);

          //## Operation: ranlux%44ECCACE010D
          void ranlux (float* rvec, int lenv);

          //## Operation: rluxin%44ECCACE01B2
          void rluxin (const int* isdext);

          //## Operation: rluxut%44ECCACE0209
          void rluxut (int* isdext) const;

          //## Operation: rluxat%44ECCACE0260
          void rluxat (int& lout, int& inout, int& k1, int& k2) const;

        // Additional Public Declarations
          //## begin Numerics::RandomLux%44ECC77F015A.public preserve=yes
          //## end Numerics::RandomLux%44ECC77F015A.public

      protected:
        // Additional Protected Declarations
          //## begin Numerics::RandomLux%44ECC77F015A.protected preserve=yes
          //## end Numerics::RandomLux%44ECC77F015A.protected

      private:
        //## Constructors (generated)
          RandomLux(const RandomLux &right);

        //## Assignment Operation (generated)
          RandomLux & operator=(const RandomLux &right);

        // Additional Private Declarations
          //## begin Numerics::RandomLux%44ECC77F015A.private preserve=yes
          //## end Numerics::RandomLux%44ECC77F015A.private

      private: //## implementation
        // Data Members for Class Attributes

          //## Attribute: LXDFLT%44ECCA880224
          //## begin Numerics::RandomLux::LXDFLT%44ECCA880224.attr preserve=no  private: static const int {U} 3
          static const int s_LXDFLT;
          //## end Numerics::RandomLux::LXDFLT%44ECCA880224.attr

          //## Attribute: IGIGA%44ECCA950331
          //## begin Numerics::RandomLux::IGIGA%44ECCA950331.attr preserve=no  private: static const int {U} 1000000000
          static const int s_IGIGA;
          //## end Numerics::RandomLux::IGIGA%44ECCA950331.attr

          //## Attribute: JSDFLT%44ECCA95035A
          //## begin Numerics::RandomLux::JSDFLT%44ECCA95035A.attr preserve=no  private: static const int {U} 314159265
          static const int s_JSDFLT;
          //## end Numerics::RandomLux::JSDFLT%44ECCA95035A.attr

          //## Attribute: ITWO24%44ECCAB002E7
          //## begin Numerics::RandomLux::ITWO24%44ECCAB002E7.attr preserve=no  private: static const int {U} 16777216
          static const int s_ITWO24;
          //## end Numerics::RandomLux::ITWO24%44ECCAB002E7.attr

          //## Attribute: ICONS%44ECCAB00317
          //## begin Numerics::RandomLux::ICONS%44ECCAB00317.attr preserve=no  private: static const int {U} 2147483563
          static const int s_ICONS;
          //## end Numerics::RandomLux::ICONS%44ECCAB00317.attr

          //## Attribute: TWOP12%44ECCAB00347
          //## begin Numerics::RandomLux::TWOP12%44ECCAB00347.attr preserve=no  private: static float {U} 4096.
          static float s_TWOP12;
          //## end Numerics::RandomLux::TWOP12%44ECCAB00347.attr

          //## Attribute: twom24%44ECCAB10079
          //## begin Numerics::RandomLux::twom24%44ECCAB10079.attr preserve=no  private: static float {U} -1.
          static float s_twom24;
          //## end Numerics::RandomLux::twom24%44ECCAB10079.attr

          //## Attribute: twom12%44ECCAB100B8
          //## begin Numerics::RandomLux::twom12%44ECCAB100B8.attr preserve=no  private: static float {U} -1.
          static float s_twom12;
          //## end Numerics::RandomLux::twom12%44ECCAB100B8.attr

          //## Attribute: next%44ECCAB20177
          //## begin Numerics::RandomLux::next%44ECCAB20177.attr preserve=no  private: static int[24] {U} 
          static int s_next[24];
          //## end Numerics::RandomLux::next%44ECCAB20177.attr

          //## Attribute: notyet%44ECCAB0037B
          //## begin Numerics::RandomLux::notyet%44ECCAB0037B.attr preserve=no  private: bool {U} 
          bool m_notyet;
          //## end Numerics::RandomLux::notyet%44ECCAB0037B.attr

          //## Attribute: i24%44ECCAB003B3
          //## begin Numerics::RandomLux::i24%44ECCAB003B3.attr preserve=no  private: int {U} 
          int m_i24;
          //## end Numerics::RandomLux::i24%44ECCAB003B3.attr

          //## Attribute: j24%44ECCAB10001
          //## begin Numerics::RandomLux::j24%44ECCAB10001.attr preserve=no  private: int {U} 
          int m_j24;
          //## end Numerics::RandomLux::j24%44ECCAB10001.attr

          //## Attribute: carry%44ECCAB1003C
          //## begin Numerics::RandomLux::carry%44ECCAB1003C.attr preserve=no  private: float {U} 
          float m_carry;
          //## end Numerics::RandomLux::carry%44ECCAB1003C.attr

          //## Attribute: luxlev%44ECCAB100FA
          //## begin Numerics::RandomLux::luxlev%44ECCAB100FA.attr preserve=no  private: int {U} 
          int m_luxlev;
          //## end Numerics::RandomLux::luxlev%44ECCAB100FA.attr

          //## Attribute: nskip%44ECCAB1013D
          //## begin Numerics::RandomLux::nskip%44ECCAB1013D.attr preserve=no  private: int {U} 
          int m_nskip;
          //## end Numerics::RandomLux::nskip%44ECCAB1013D.attr

          //## Attribute: in24%44ECCAB10186
          //## begin Numerics::RandomLux::in24%44ECCAB10186.attr preserve=no  private: int {U} 
          int m_in24;
          //## end Numerics::RandomLux::in24%44ECCAB10186.attr

          //## Attribute: kount%44ECCAB101CE
          //## begin Numerics::RandomLux::kount%44ECCAB101CE.attr preserve=no  private: int {U} 
          int m_kount;
          //## end Numerics::RandomLux::kount%44ECCAB101CE.attr

          //## Attribute: mkount%44ECCAB1021B
          //## begin Numerics::RandomLux::mkount%44ECCAB1021B.attr preserve=no  private: int {U} 
          int m_mkount;
          //## end Numerics::RandomLux::mkount%44ECCAB1021B.attr

          //## Attribute: inseed%44ECCAB1026A
          //## begin Numerics::RandomLux::inseed%44ECCAB1026A.attr preserve=no  private: int {U} 
          int m_inseed;
          //## end Numerics::RandomLux::inseed%44ECCAB1026A.attr

          //## Attribute: seeds%44ECCAB102BA
          //## begin Numerics::RandomLux::seeds%44ECCAB102BA.attr preserve=no  private: float[24] {U} 
          float m_seeds[24];
          //## end Numerics::RandomLux::seeds%44ECCAB102BA.attr

        // Additional Implementation Declarations
          //## begin Numerics::RandomLux%44ECC77F015A.implementation preserve=yes
          const static int s_MAXLEV;
          const static int s_ndskip[];
          //## end Numerics::RandomLux%44ECC77F015A.implementation
    };

    //## begin Numerics::RandomLux%44ECC77F015A.postscript preserve=yes
    //## end Numerics::RandomLux%44ECC77F015A.postscript

    // Class Numerics::RandomLux 

} // namespace Numerics

//## begin module%44ECC6CC0237.epilog preserve=yes
//## end module%44ECC6CC0237.epilog


#endif
